//
//
// C++ Interface: $MODULE$
//
// Description: 
//
//
// Author: Juan Linietsky <coding@reduz.com.ar>, (C) 2003
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef EFFECT_CHAIN_H
#define EFFECT_CHAIN_H


#include "components/audio/effect.h"
#include <vector>
	using std::vector;
/**
@author Juan Linietsky
*/
class Effect_Chain {

	vector<Effect*> chain;


public:

	void add_effect(Effect *p_effect);
	int get_effect_count();
	Effect* get_effect(int p_which);
	bool remove_effect(int p_which);

	bool move_effect_up(int p_which);
	bool move_effect_down(int p_which);

	void process_buffer(sample_t *p_buffer,int p_length,bool p_stereo,int p_mix_freq);


	Effect_Chain();
	~Effect_Chain();

};

#endif
